### Method

# Camel MimeParser read

#### Declaration [src]

    gssize
    camel_mime_parser_read (
      CamelMimeParser* parser,
      const gchar** databuffer,
      gssize len,
      GError** error
    )

#### Description [src]

Read at most `len` bytes from the internal mime parser buffer.

Returns the address of the internal buffer in `databuffer`, and the length of useful data.

`len` may be specified as `G_MAXSSIZE`, in which case you will get the full remainder of the buffer at each call.

Note that no parsing of the data read through this function occurs, so no state changes occur, but the seek position is updated appropriately.

#### Parameters

`databuffer`

  Type: An array of `guint8`

  The data buffer.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`len`

  Type: `gssize`

  The length of data to read.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gssize`

The number of bytes available, or -1 on error.